<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class HomeController extends AbstractController
{
    #[Route('/', name: 'home')]
    public function index(): Response
    {
        $emojisDeBase = [
            [
                'id' => 1,
                'nom' => 'Bob',
                'code' => '😊',
                'force' => 12.5,
                'robustesse' => 9.3,
                'intelligence' => 7.8,
                'vitesse' => 10.0,
                'nbCombatGagne' => 3,
                'rarete' => 3, // épique
            ],
            [
                'id' => 2,
                'nom' => 'John',
                'code' => '😭',
                'force' => 5.1,
                'robustesse' => 4.2,
                'intelligence' => 3.3,
                'vitesse' => 6.0,
                'nbCombatGagne' => 1,
                'rarete' => 1, // commun
            ],
            [
                'id' => 3,
                'nom' => 'Rodolph',
                'code' => '😁',
                'force' => 20.0,
                'robustesse' => 15.0,
                'intelligence' => 18.0,
                'vitesse' => 17.0,
                'nbCombatGagne' => 10,
                'rarete' => 5, // légendaire
            ],
            [
                'id' => 4,
                'nom' => 'Sophie',
                'code' => '😎',
                'force' => 8.0,
                'robustesse' => 7.5,
                'intelligence' => 9.0,
                'vitesse' => 8.5,
                'nbCombatGagne' => 2,
                'rarete' => 4, // mythique
            ]
        ];

        $emojisCrees = [
            [
                'id' => 6,
                'nom' => 'Benoit',
                'code' => '🤖',
                'force' => 15.0,
                'robustesse' => 12.0,
                'intelligence' => 14.0,
                'vitesse' => 13.0,
                'nbCombatGagne' => 5,
                'rarete' => 3, // épique
            ],
            [
                'id' => 7,
                'nom' => 'Eric',
                'code' => '🌟',
                'force' => 18.0,
                'robustesse' => 16.0,
                'intelligence' => 17.0,
                'vitesse' => 19.0,
                'nbCombatGagne' => 8,
                'rarete' => 5, // légendaire
            ],
            [
                'id' => 5,
                'nom' => 'Alice',
                'code' => '🥳',
                'force' => 6.0,
                'robustesse' => 5.0,
                'intelligence' => 4.5,
                'vitesse' => 6.5,
                'nbCombatGagne' => 0,
                'rarete' => 2, // rare
            ],
            [
                'id' => 8,
                'nom' => 'Bobette',
                'code' => '🤩',
                'force' => 10.0,
                'robustesse' => 9.0,
                'intelligence' => 11.0,
                'vitesse' => 12.0,
                'nbCombatGagne' => 4,
                'rarete' => 4, // mythique
            ],
            [
                'id' => 9,
                'nom' => 'Charlie',
                'code' => '😇',
                'force' => 7.0,
                'robustesse' => 6.0,
                'intelligence' => 8.0,
                'vitesse' => 7.5,
                'nbCombatGagne' => 2,
                'rarete' => 1, // commun
            ],
            [
                'id' => 10,
                'nom' => 'Diana',
                'code' => '😈',
                'force' => 14.0,
                'robustesse' => 13.0,
                'intelligence' => 15.0,
                'vitesse' => 16.0,
                'nbCombatGagne' => 6,
                'rarete' => 4, // mythique
            ],
            [
                'id' => 11,
                'nom' => 'Ethan',
                'code' => '🤯',
                'force' => 9.0,
                'robustesse' => 8.0,
                'intelligence' => 10.0,
                'vitesse' => 11.0,
                'nbCombatGagne' => 3,
                'rarete' => 3, // épique
            ],
            [
                'id' => 12,
                'nom' => 'Fiona',
                'code' => '🥺',
                'force' => 4.0,
                'robustesse' => 3.5,
                'intelligence' => 5.0,
                'vitesse' => 4.5,
                'nbCombatGagne' => 1,
                'rarete' => 1, // commun
            ],
            [
                'id' => 13,
                'nom' => 'George',
                'code' => '😜',
                'force' => 11.0,
                'robustesse' => 10.0,
                'intelligence' => 12.0,
                'vitesse' => 13.5,
                'nbCombatGagne' => 2,
                'rarete' => 3, // épique
            ],
            [
                'id' => 14,
                'nom' => 'Hannah',
                'code' => '😏',
                'force' => 3.0,
                'robustesse' => 2.5,
                'intelligence' => 4.0,
                'vitesse' => 3.5,
                'nbCombatGagne' => 0,
                'rarete' => 2, // rare
            ],
            [
                'id' => 15,
                'nom' => 'Ian',
                'code' => '😬',
                'force' => 17.0,
                'robustesse' => 14.0,
                'intelligence' => 16.0,
                'vitesse' => 18.0,
                'nbCombatGagne' => 7,
                'rarete' => 5, // légendaire
            ],
        ];

        foreach ($emojisDeBase as &$emoji) {
            $emoji['color'] = match ($emoji['rarete']) {
                2 => 'green',
                3 => 'purple',
                4 => 'red',
                5 => 'gold',
                default => 'gray',
            };
        }

        foreach ($emojisCrees as &$emoji) {
            $emoji['color'] = match ($emoji['rarete']) {
                2 => 'green',
                3 => 'purple',
                4 => 'red',
                5 => 'gold',
                default => 'gray',
            };
        }


        return $this->render('home/index.html.twig', [
            'emojisDeBase' => $emojisDeBase,
            'emojisCrees' => $emojisCrees,
        ]);
    }
}
