<?php

namespace App\Entity;

use App\Repository\EmojiRepository;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: EmojiRepository::class)]
class Emoji
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $name = null;

    #[ORM\Column(length: 255)]
    private ?string $code = null;

    #[ORM\Column]
    private ?float $strength = null;

    #[ORM\Column]
    private ?float $toughness = null;

    #[ORM\Column]
    private ?float $intelligence = null;

    #[ORM\Column]
    private ?float $speed = null;

    #[ORM\Column]
    private ?int $fightsWon = null;

    #[ORM\ManyToOne(targetEntity: Rarity::class)]
    #[ORM\JoinColumn(nullable: false)]
    private ?Rarity $rarity = null;

    #[ORM\ManyToOne(targetEntity: self::class)]
    #[ORM\JoinColumn(nullable: true)]
    private ?Emoji $parent1 = null;

    #[ORM\ManyToOne(targetEntity: self::class)]
    #[ORM\JoinColumn(nullable: true)]
    private ?Emoji $parent2 = null;

    public function getParent1(): ?self
    {
        return $this->parent1;
    }

    public function setParent1(?self $parent1): self
    {
        $this->parent1 = $parent1;
        return $this;
    }

    public function getParent2(): ?self
    {
        return $this->parent2;
    }

    public function setParent2(?self $parent2): self
    {
        $this->parent2 = $parent2;
        return $this;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;
        return $this;
    }

    public function getCode(): ?string
    {
        return $this->code;
    }

    public function setCode(string $code): self
    {
        $this->code = $code;
        return $this;
    }

    public function getStrength(): ?float
    {
        return $this->strength;
    }

    public function setStrength(float $strength): self
    {
        $this->strength = $strength;
        return $this;
    }

    public function getToughness(): ?float
    {
        return $this->toughness;
    }

    public function setToughness(float $toughness): self
    {
        $this->toughness = $toughness;
        return $this;
    }

    public function getIntelligence(): ?float
    {
        return $this->intelligence;
    }

    public function setIntelligence(float $intelligence): self
    {
        $this->intelligence = $intelligence;
        return $this;
    }

    public function getSpeed(): ?float
    {
        return $this->speed;
    }

    public function setSpeed(float $speed): self
    {
        $this->speed = $speed;
        return $this;
    }

    public function getFightsWon(): ?int
    {
        return $this->fightsWon;
    }

    public function setFightsWon(int $fightsWon): self
    {
        $this->fightsWon = $fightsWon;
        return $this;
    }

    public function getRarity(): ?Rarity
    {
        return $this->rarity;
    }

    public function setRarity(Rarity $rarity): self
    {
        $this->rarity = $rarity;
        return $this;
    }

    public function wonFight() : self{
        $this->fightsWon = $this->fightsWon + 1;
        $this->strength += 1;
        $this->toughness += 1;
        $this->intelligence += 1;
        $this->speed += 1;
        return $this;
    }
}
